package de.mcs.utils.caches;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import org.junit.Test;

import de.mcs.utils.caches.ObjectCache.TIMEMODE;

public class TestObjectCache extends TestCase {

  @Test
  public void test() {
    List<String> list = new ArrayList<String>();
    ObjectCache<Object> cache = new ObjectCache<Object>(10);

    for (int i = 1; i < 11; i++) {
      list.add(cache.addObject(new Integer(i)));
      try {
        Thread.sleep(100);
      } catch (InterruptedException e) {
        e.printStackTrace();
      }
    }
    assertEquals(10, cache.getCacheCount());

    list.add(cache.addObject(new Integer(11)));
    try {
      Thread.sleep(100);
    } catch (InterruptedException e) {
      e.printStackTrace();
    }
    assertEquals(10, cache.getCacheCount());

    String first = list.get(0);
    Object object = cache.getObject(first);
    // assertNull(object);

    for (int i = 1; i < 11; i++) {
      String id = list.get(i);
      object = cache.getObject(id);
      // assertNotNull(object);
    }

  }

  @Test
  public void testAutoRemoveCreate() throws InterruptedException {
    ObjectCache<String> objectCache = new ObjectCache<>();
    objectCache.setTimemode(TIMEMODE.CREATION);

    List<String> ids = new ArrayList<>();

    for (int i = 0; i < 100; i++) {
      String entry = String.format("string%d", i);
      String sId = objectCache.addObject(entry);
      ids.add(sId);
    }
    assertEquals(100, objectCache.size());

    System.out.println("wait");
    Thread.sleep(500);

    System.out.println("start cleanup task");
    objectCache.startCleanupTask(1, "cleanup");

    assertEquals(100, objectCache.size());

    System.out.println("wait for removal.");
    Thread.sleep(2000);

    System.out.println("everything should be removed.");
    assertEquals(0, objectCache.size());
  }
}
